#Del for oppsett av programmer i setupdelen

import wx			    
import os
import shutil
import threading
import  wx.lib.scrolledpanel as scrolled

class BspSetup(wx.Panel):
	def __init__(self,parent,prog):
		self.programs=prog[6]
		
		wx.Panel.__init__(self,parent,-1)
		self.proPath=prog[1]
		self.parent=parent
		
		self.progPan=BspProgPan(self,self.programs,prog)#,flag=wx.GROW)
		layout=wx.LayoutConstraints()
		layout.top.SameAs(self, wx.Top, 3)
		layout.left.SameAs(self, wx.Left, 3)
		layout.bottom.SameAs(self,wx.Bottom,3)
		layout.right.PercentOf(self,wx.Right, 30)
		self.progPan.SetConstraints(layout)
		
		
		self.progSetPan=BspProgSetPan(self,self.programs)
		layout=wx.LayoutConstraints()
		layout.top.SameAs(self, wx.Top, 3)
		layout.left.RightOf(self.progPan, 3)
		layout.bottom.SameAs(self,wx.Bottom,3)
		layout.right.SameAs(self,wx.Right, 3)
		self.progSetPan.SetConstraints(layout)
		
		
		#self.progSetPan.Enable(False)
		#sizFig.Add(self.progSetPan)#,flag=wx.GROW)

    
        	#self.figbox.Add((15,15))
        	#self.figbox.Add(sizFig,flag=wx.GROW)
        	#self.SetSizer(self.figbox)
        	self.SetAutoLayout(True)

class BspProgPan(wx.Panel):
	def __init__(self,parent,prog,topProg):
		wx.Panel.__init__(self,parent,-1,style=wx.RAISED_BORDER)
		self.parent=parent
		self.prog=prog
		self.topProg=topProg
		sizPrg=wx.FlexGridSizer(cols=1,hgap=5,vgap=10)
		self.dataTre= wx.TreeCtrl(self, -1 ,size=(200,200),style=wx.TR_HAS_BUTTONS )
		self.root=self.dataTre.AddRoot('BSPLab Programs in Project')
		self.addKnapp= wx.Button(self, 10, "Add", (10, 10))
		self.addKnapp.Bind(wx.EVT_BUTTON, self.OnPressAdd)
		#self.newKnapp= wx.Button(self, 10, "New", (10, 10))
		#self.newKnapp.Bind(wx.EVT_BUTTON, self.OnPressNew)
		#self.removeKnapp= wx.Button(self, 10, "Remove", (10, 10))
		#self.removeKnapp.Bind(wx.EVT_BUTTON, self.OnPressRemove)
		#self.deleteKnapp= wx.Button(self, 10, "Delete", (10, 10))
		#self.deleteKnapp.Bind(wx.EVT_BUTTON, self.OnPressDelete)
		#sizFig.Add(self.dataTre)
		#self.dataTre.AppendItem(self.root,'c:/programfiles/bspproject/est/bspPrg.exe')
		#self.dataTre.AppendItem(self.root,'bspPrg.exe')
		#self.dataTre.AppendItem(self.root,'bspPrg.exe')
		#self.dataTre.AppendItem(self.root,'bspPrg.exe')
		#self.dataTre.AppendItem(self.root,'bspPrg.exe')
		sizPrg.Add((0,20))
		bsizPrg=wx.BoxSizer(wx.HORIZONTAL)
		sizPrg.Add(self.dataTre)
		self.Bind(wx.EVT_TREE_ITEM_RIGHT_CLICK,self.OnRightClick,self.dataTre)
		self.Bind(wx.EVT_TREE_SEL_CHANGED,self.OnChangeClick,self.dataTre)
		self.Bind(wx.EVT_SET_FOCUS,self.Non)
		bsizPrg.Add((2,2))
		bsizPrg.Add(self.addKnapp,flag=wx.ALIGN_CENTER)
		#bsizPrg.Add(self.newKnapp,flag=wx.ALIGN_CENTER)
		#bsizPrg.Add(self.removeKnapp,flag=wx.ALIGN_CENTER)
		#bsizPrg.Add(self.deleteKnapp,flag=wx.ALIGN_CENTER)
		bsizPrg.Add((2,2))
		sizPrg.Add(bsizPrg,flag=wx.ALIGN_CENTER)
		sizPrg.Add((200,500))
		self.dataTre.Expand(self.root)
		self.SetSizer(sizPrg)
		
		t=self.prog.keys()
		t.sort
		for element in t:
                        if self.prog[element][6][1]==1:
                            l=self.dataTre.AppendItem(self.root,element)
			elif self.prog[element][6][2]==0:
                            l=self.dataTre.AppendItem(self.root,element)
                            self.dataTre.AppendItem(l,element+" Run:"+str(0))
                        else:
                            self.dataTre.AppendItem(l,str(element))
			    self.dataTre.Expand(l)	                            
		self.dataTre.Expand(self.root)		
	def OnPressAdd(self,event):
		text='Give the Program a Title:'
		while 1:
			dlgT=wx.TextEntryDialog(self,text,'Program Title',style=wx.OK|wx.CANCEL)
			if dlgT.ShowModal()==wx.ID_OK:
				name=dlgT.GetValue()
				if self.prog.has_key(name):
					
					text='You Already Has a Program With That Name. Please Try Again:'
				else:
					
					
					progList=[]

					path=self.parent.proPath+'/'+name+'/'
					os.mkdir(path)
					dlg = wx.FileDialog(self, message="Choose a BSPLab program", defaultDir=os.getcwd(), 
					defaultFile="", wildcard='BSPLab program (*.exe)|*.exe', style=wx.OPEN | wx.CHANGE_DIR)

					if dlg.ShowModal() == wx.ID_OK:
						print dlg.GetPath()
						shutil.copy(dlg.GetPath(),path)
						t=self.dataTre.AppendItem(self.root,name)
						self.dataTre.Expand(self.root)
						self.dataTre.SetPyData(t,(0,1))
						progList.append(path)
						progList.append(dlg.GetFilename())
						progList.append(1)
						progList.append(0)
						progList.append([])
						progList.append([])
						progList.append((0,1,0,0))#Type 1 Level 1 Run 0
						progList.append(None)
						self.prog[name]=progList
						#self.topProg[10]=self.dataTre
					break
			else:
				break
	def OnPressNew(self,event):
		text='Give the Program a Title:'
		while 1:
			dlgT=wx.TextEntryDialog(self,text,'Program Title',style=wx.OK|wx.CANCEL)
			if dlgT.ShowModal()==wx.ID_OK:
				name=dlgT.GetValue()
				if self.prog.has_key(name):

					text='You already have a program with that name, in this project. Please Try Again:'
				else:


					progList=[]

					path=self.parent.proPath+'/'+name+'/'
					os.mkdir(path)





					
					t=self.dataTre.AppendItem(self.root,name)
					self.dataTre.SetPyData(t,(0,1))
					progList.append(path)
					progList.append('bspprog.exe')
					progList.append(1)//level
					progList.append(0)
					progList.append([])
					progList.append([])
					progList.append((1,1,0,0))#Type 1, level 1, run 0
					progList.append(None)
					self.prog[name]=progList
					#self.topProg[10]=self.dataTre
					shutil.copy('bspprog.dev',path)
					self.t=OpenDev(path+'bspprog.dev')
					self.t.start()
					
					
					break
			else:
				break
		
		
	
	def OnPressRemove(self,event):
		print self.parent.programs
	def OnPressDelete(self,event):
		None
	def Non(self,event):
		print 'kkk'
		event.StopPropagation()
		
		
	def OnRightClick(self,event):
		menu = wx.Menu()
        	item = wx.MenuItem(menu, 1,"Add Run")
        	self.Bind(wx.EVT_MENU, self.OnAddRun, id=1)
        	menu.AppendItem(item)
        	self.PopupMenu(menu)
        	menu.Destroy()
        def OnAddRun(self,event):
        	item=self.dataTre.GetSelection()
        	title= self.dataTre.GetItemText(item)
        	parTitle=self.dataTre.GetItemText(self.dataTre.GetItemParent(item))
                if title==parTitle+" Run:0":
                    title=parTitle
        	numberOfRuns=self.prog[title][6][3]
                if numberOfRuns==0:
                    self.prog[title][6]=(self.prog[title][6][0],2,0,1)
                    self.dataTre.AppendItem(item,str(title)+" Run:"+str(numberOfRuns))
                else:
                    self.prog[title][6]=(1,2,0,numberOfRuns+1)
                
                self.dataTre.AppendItem(item,str(title)+" Run:"+str(numberOfRuns+1))
                
                progList=[]
		progList.append(self.prog[title][0])
		progList.append(self.prog[title][1])
		progList.append(self.prog[title][2])
		progList.append(self.prog[title][3])
		progList.append(self.prog[title][4])
		progList.append(self.prog[title][5])
		progList.append((self.prog[title][6][0],2,numberOfRuns+1,1))
                self.prog[title+" Run:"+str(numberOfRuns+1)]=progList                      
        	print numberOfRuns
        def OnChangeClick(self,event):
        	
        	if self.dataTre.ItemHasChildren(self.dataTre.GetSelection())==False:
                        item=self.dataTre.GetSelection()
        		title=self.dataTre.GetItemText(self.dataTre.GetSelection())
                        parTitle=self.dataTre.GetItemText(self.dataTre.GetItemParent(item))
                        print parTitle
                        if title==parTitle+" Run:0":
                            self.parent.progSetPan.SetData(self.prog[parTitle],parTitle)
                        else:
                            self.parent.progSetPan.SetData(self.prog[title],title)
        	
        	
        	
        	
class OpenDev(threading.Thread):
	def __init__(self,path):
                threading.Thread.__init__(self, name="runThread")
		self.path=path
             
        def run(self):
                t=os.system(self.path)	
		
class BspProgSetPan(scrolled.ScrolledPanel):#wx.Panel):
	def __init__(self,parent,prog):
		ctrls=[]
		scrolled.ScrolledPanel.__init__(self,parent,-1,style=wx.SIMPLE_BORDER)#wx.Panel.__init__(self,parent,-1,style=wx.SIMPLE_BORDER)
		self.parent=parent
		self.prog=prog
		self.boxSiz=wx.BoxSizer(wx.VERTICAL)
		figbox_title=wx.StaticBox(self,-1,'BSPLab Program')
		figbox_title.SetFont(wx.Font(10,wx.FONTFAMILY_MODERN, wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD,False))
		figbox=wx.StaticBoxSizer(figbox_title, wx.VERTICAL)
		sizFig=wx.FlexGridSizer(cols=2,hgap=5,vgap=10)
		self.progFileL=wx.StaticText(self,-1, 'BSPLab Program File:')
		self.progFileT=wx.StaticText(self,-1, 'test.bpr')
		self.progTitleL=wx.StaticText(self,-1, 'Program Title:')
		self.progTitleT=wx.StaticText(self,-1,"")
		self.argL=wx.StaticText(self,-1, 'Argument:')
		self.argT=wx.TextCtrl(self,-1,"",size=(255, -1))
		
		self.progDescL=wx.StaticText(self,-1, 'Program Description:')
		self.progDescT=wx.TextCtrl(self,-1,"",size=(255, -1),style=wx.TE_MULTILINE)

		sizFig.Add((0,5))
		sizFig.Add((440,5))
		sizFig.Add(self.progFileL)
		sizFig.Add(self.progFileT)
		sizFig.Add(self.progTitleL)
		sizFig.Add(self.progTitleT)
		sizFig.Add(self.argL)
		sizFig.Add(self.argT)
		sizFig.Add(self.progDescL)
		sizFig.Add(self.progDescT)
		figbox.Add(sizFig)
		        	
		        	
		        	
        	sizFig.Add((0,0))
        	figboxM_title=wx.StaticBox(self,-1,'General BSPLab Machine Parameters')
		figboxM_title.SetFont(wx.Font(10,wx.FONTFAMILY_MODERN, wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD,False))
		figboxM=wx.StaticBoxSizer(figboxM_title, wx.VERTICAL)
		sizFigM=wx.FlexGridSizer(cols=2,hgap=10,vgap=8)
		machTSiz=wx.BoxSizer(wx.HORIZONTAL)
		self.machL=wx.StaticText(self,-1, 'BSPLab Machine:')
		self.rNull=wx.RadioButton(self, -1, 'Null',style = wx.RB_GROUP)
        	self.rSimple=wx.RadioButton(self,-1,'Simple')
        	self.rNow=wx.RadioButton(self,-1,'NOW')
        	self.rBus=wx.RadioButton(self,-1,'Bus')
        	self.rNet=wx.RadioButton(self,-1,'Network')
        	self.rGroup=[]
		self.rGroup.append(self.rNull)
        	self.rGroup.append(self.rSimple)
		self.rGroup.append(self.rNow)
		self.rGroup.append(self.rBus)
		self.rGroup.append(self.rNet)
		for radio in self.rGroup:
	        	self.Bind(wx.EVT_RADIOBUTTON, self.OnMachSelect, radio )
		machTSiz.Add(self.rNull)
		machTSiz.Add((3,3))
		machTSiz.Add(self.rSimple)
		machTSiz.Add((3,3))
		machTSiz.Add(self.rNow)
		machTSiz.Add((3,3))
		machTSiz.Add(self.rBus)
		machTSiz.Add((3,3))
		machTSiz.Add(self.rNet)
		
        	sizFigM.Add(self.machL)
		sizFigM.Add(machTSiz)
		
		
		timSiz=wx.BoxSizer(wx.HORIZONTAL)
		self.timL=wx.StaticText(self,-1, 'Timing of Code:')
		self.rAut=wx.RadioButton(self,-1,'Automatic',style = wx.RB_GROUP)
		self.rMan=wx.RadioButton(self,-1,'Manual')
		self.rTimGroup=[]
		self.rTimGroup.append(self.rAut)
        	self.rTimGroup.append(self.rMan)
		
		timSiz.Add(self.rAut)
		timSiz.Add((3,3))
		timSiz.Add(self.rMan)
		sizFigM.Add(self.timL)
		sizFigM.Add(timSiz)
		
		cpuSiz=wx.BoxSizer(wx.HORIZONTAL)
		self.cpuBenchL=wx.StaticText(self,-1, 'Automatic CPU Timing:')
		self.rBenchOn=wx.RadioButton(self,-1,'On',style = wx.RB_GROUP)
		self.rBenchOff=wx.RadioButton(self,-1,'Off')
		self.rBenchGroup=[]
		self.rBenchGroup.append(self.rBenchOn)
		self.rBenchGroup.append(self.rBenchOff)
				
		cpuSiz.Add(self.rBenchOn)
		cpuSiz.Add((3,3))
		cpuSiz.Add(self.rBenchOff)
		sizFigM.Add(self.cpuBenchL)
		sizFigM.Add(cpuSiz)
		
		self.cpuSpeedL=wx.StaticText(self,-1, 'CPU Speed:')
		self.cpuSpeedT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFigM.Add(self.cpuSpeedL)
		sizFigM.Add(self.cpuSpeedT)
		
		self.cpuVirtSpeedL=wx.StaticText(self,-1, 'Virtual CPU Speed:')
		self.cpuVirtSpeedT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFigM.Add(self.cpuVirtSpeedL)
		sizFigM.Add(self.cpuVirtSpeedT)
		
		self.stackSizeL=wx.StaticText(self,-1, 'Stack Size:')
		self.stackSizeT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFigM.Add(self.stackSizeL)
		sizFigM.Add(self.stackSizeT)
		
		self.overheadL=wx.StaticText(self,-1, 'OVERHEAD VALUES:')
		sizFigM.Add(self.overheadL)
		sizFigM.Add((0,0))
		
		self.byInGetL=wx.StaticText(self,-1, 'Bytes in Get Message:')
		self.byInGetT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFigM.Add(self.byInGetL)
		sizFigM.Add(self.byInGetT)
		
		self.bsmpMesMarkL=wx.StaticText(self,-1, 'BSMP Mes. Mark Size:')
		self.bsmpMesMarkT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFigM.Add(self.bsmpMesMarkL)
		sizFigM.Add(self.bsmpMesMarkT)
		
		self.byInSyncMesL=wx.StaticText(self,-1, 'Bytes in Sync Message:')
		self.byInSyncMesT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFigM.Add(self.byInSyncMesL)
		sizFigM.Add(self.byInSyncMesT)
		
		self.timPacL=wx.StaticText(self,-1, 'Time to Start Packetizing:')
		self.timPacT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFigM.Add(self.timPacL)
		sizFigM.Add(self.timPacT)
		
		self.timPacOneL=wx.StaticText(self,-1, 'Time to Packetize one Byte:')
		self.timPacOneT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFigM.Add(self.timPacOneL)
		sizFigM.Add(self.timPacOneT)
		
		figboxM.Add((10,10))
		figboxM.Add(sizFigM)
		self.boxSiz.Add(figbox,flag=wx.GROW)
		self.boxSiz.Add(figboxM)#flag=wx.GROW)
		self.machPan=SimpleSetPan(self)
		self.boxSiz.Add(self.machPan)#,flag=wx.GROW)
		self.saveBtn=wx.Button(self,-1,'Save Changes')
	        self.Bind(wx.EVT_BUTTON,self.OnSavePress,self.saveBtn)
                self.saveBtn.Enable(False)
	        self.boxSiz.Add(self.saveBtn)
		self.SetSizer(self.boxSiz)
        	self.SetAutoLayout(True)
        	#self.SetScrollbars(0,20, 10, 10, 0, 0, True)
        	self.SetupScrolling()
        	#self.SetScrollbars(0,20, 10, 10, 0, 0, True)
        	#self.SetScrollbar(wx.VERTICAL, 0, 10, 15, False)
        def GetData(self):
        	label=[]
        	data=[]
        	if self.rNull.GetValue():
        		label.append("[BSPMachine]")
        		data.append("Null")
        	elif self.rSimple.GetValue():
        		label.append("[BSPMachine]")
        		data.append("Simple")
        	
        	elif self.rBus.GetValue():
        		label.append("[BSPMachine]")
        		data.append("Bus")
        	elif self.rNow.GetValue():
		        label.append("[BSPMachine]")
        		data.append("NOW")
        	else:	
        		
			label.append("[BSPMachine]")
        		data.append("Network")
        	
        	if self.rAut.GetValue():
		        label.append("[AutomaticTiming]")
        		data.append('On')
        		label.append("[ManualTiming]")
        		data.append('Off')
        	else:
        		label.append("[AutomaticTiming]")
			data.append('Off')
			label.append("[ManualTiming]")
        		data.append('On')
        	if self.rBenchOn.GetValue():
			label.append("[AutomaticCPUTiming]")
        		data.append('On')
        	else:
        		label.append("[AutomaticCPUTiming]")
        		data.append('Off')
        	
        	label.append("[ThisCPUSpeed]")
        	data.append(self.cpuSpeedT.GetValue())
        	
        	label.append("[VirtualCPUSpeed]")
        	data.append(self.cpuVirtSpeedT.GetValue())
        	
        	label.append("[StackSize]")
        	data.append(self.stackSizeT.GetValue())
        	
        	label.append("[BytesInGetMessage]")
        	data.append(self.byInGetT.GetValue())
        	
        	label.append("[BSMPMessageMarkSize]")
        	data.append(self.bsmpMesMarkT.GetValue())
        	
        	label.append("[BytesInSyncMessage]")
        	data.append(self.byInSyncMesT.GetValue())
        	
        	label.append("[TimeToStartPacketizing]")
        	data.append(self.timPacT.GetValue())
        	
        	label.append("[TimeToPacketizeOneByte]")
        	data.append(self.timPacOneT.GetValue())
        	
        	t=self.machPan.getData()
        	ret=[]
        	title=self.progTitleT.GetLabel()
        	ret.append(title)
        	ret.append((label,data))
        	ret.append(t)
        	ret.append(self.argT.GetValue())
        	
        	return ret
        	
        def OnSavePress(self,event):
        	r= self.GetData()
        	title=r[0]
        	self.prog[title][3]=1
        	self.prog[title][4]=r[1]
        	self.prog[title][5]=r[2]
        	self.prog[title][7]=r[3]
        def OnMachSelect(self,event):
	        radio=event.GetEventObject()
	        t= radio.GetLabel()
	        
	        if t=='Null':
	        	machPan=NullSetPan(self)
	        elif t=='Simple':
	        	machPan=SimpleSetPan(self)
	        elif t=='NOW':
	        	machPan=NOWSetPan(self)
	        elif t=='Bus':
	        	machPan=BusSetPan(self)
	        elif t=='Network':
	        	machPan=NetworkSetPan(self)
	        #self.boxSiz.Detach(2)
	        self.machPan.Destroy()
	        self.boxSiz.Insert(2,machPan,flag=wx.GROW)
	        self.boxSiz.Layout()
	        self.machPan=machPan
	        self.SetupScrolling()
	        self.Refresh()
	        
	def OnMachSet(self,radio):
	        t= radio.GetLabel()
	        print self
	        if t=='Null':
	        	machPan=NullSetPan(self)
	        elif t=='Simple':
	        	machPan=SimpleSetPan(self)
	        elif t=='NOW':
	        	machPan=NOWSetPan(self)
	        elif t=='Bus':
	        	machPan=BusSetPan(self)
	        elif t=='Network':
	        	machPan=NetworkSetPan(self)
	        #self.boxSiz.Detach(2)
	        self.machPan.Destroy()
	        self.boxSiz.Insert(2,machPan,flag=wx.GROW)
	        self.boxSiz.Layout()
	        self.machPan=machPan
	        #self.parent.parent.Refresh()      
	

	def SetData(self,data,title):
		self.saveBtn.Enable(True)
		self.progTitleT.SetLabel(title)
		self.argT.SetValue(str(data[7]))
		if data[3]==1:
			if data[4][1][0]=="Null":
				self.rNull.SetValue(True)
				self.OnMachSet(self.rNull)
			elif data[4][1][0]=="Simple":
				self.rSimple.SetValue(True)
				self.OnMachSet(self.rSimple)
			elif data[4][1][0]=="NOW":
				self.rNow.SetValue(True)
				self.OnMachSet(self.rNow)
			elif data[4][1][0]=="Bus":
				self.rBus.SetValue(True)
				self.OnMachSet(self.rBus)
			else:
				self.rNet.SetValue(True)
				self.OnMachSet(self.rNet)
		
			if data[4][1][1]=="On":
				self.rAut.SetValue(True)
			else: 
				self.rMan.SetValue(True)
		
			if data[4][1][3]=="On":
				self.rBenchOn.SetValue(True)
			else: 
				self.rBenchOff.SetValue(True)
		
			self.cpuSpeedT.SetValue(data[4][1][4])
			
			self.cpuVirtSpeedT.SetValue(data[4][1][5])
			
			self.stackSizeT.SetValue(data[4][1][6])
			
			self.byInGetT.SetValue(data[4][1][7])
			
			self.bsmpMesMarkT.SetValue(data[4][1][8])
		
		
			self.byInSyncMesT.SetValue(data[4][1][9])
		
			self.timPacT.SetValue(data[4][1][10])
		
			self.timPacOneT.SetValue(data[4][1][11])
		
			self.machPan.setData(data[5][1])
		else:
			None

		
class NullSetPan(wx.Panel):
	def __init__(self,parent):
		
		wx.Panel.__init__(self,parent,-1)
		figbox_title=wx.StaticBox(self,-1,'Null Machine Setup')
		figbox_title.SetFont(wx.Font(10,wx.FONTFAMILY_MODERN, wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD,False))
		figbox=wx.StaticBoxSizer(figbox_title, wx.VERTICAL)
		sizFig=wx.FlexGridSizer(cols=2,hgap=5,vgap=10)
		self.numProcL=wx.StaticText(self,-1, 'Number Of Processors:')
		self.numProcT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add((15,15))
		sizFig.Add((15,15))
		sizFig.Add(self.numProcL)
		sizFig.Add(self.numProcT)
		sizFig.Add((15,15))
		sizFig.Add((15,15))
		figbox.Add(sizFig)
		self.SetSizer(figbox)
	
	
	def getData(self):
		label=[]
		data=[]
		
		label.append("[NumberOfProcessors]")
		data.append(self.numProcT.GetValue())
		
		ret=(label,data)
		return ret
	

	def setData(self,data):
		self.numProcT.SetValue(data[0])
		
	
		
class SimpleSetPan(wx.Panel):
	def __init__(self,parent):
		
		wx.Panel.__init__(self,parent,-1)
		figbox_title=wx.StaticBox(self,-1,'Simple Machine Setup')
		figbox_title.SetFont(wx.Font(10,wx.FONTFAMILY_MODERN, wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD,False))
		figbox=wx.StaticBoxSizer(figbox_title, wx.VERTICAL)
		sizFig=wx.FlexGridSizer(cols=2,hgap=5,vgap=10)
		self.numProcL=wx.StaticText(self,-1, 'Number Of Processors:')
		self.numProcT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add((15,15))
		sizFig.Add((15,15))
		sizFig.Add(self.numProcL)
		sizFig.Add(self.numProcT)
		
		self.syncTimeL=wx.StaticText(self,-1, 'Time To Sycronize One Processor:')
		self.syncTimeT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.syncTimeL)
		sizFig.Add(self.syncTimeT)
		
		self.sendTimeL=wx.StaticText(self,-1, 'Time To Send One Byte:')
		self.sendTimeT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.sendTimeL)
		sizFig.Add(self.sendTimeT)
		
		figbox.Add(sizFig)
		self.SetSizer(figbox)
	def getData(self):
		label=[]
		data=[]
			
		label.append("[NumberOfProcessors]")
		data.append(self.numProcT.GetValue())
		
		label.append("[Simple_TimeToSynchronizeOneProcessor]")
		data.append(self.syncTimeT.GetValue())
		
		label.append("[Simple_TimeToSendOneByte]")
		data.append(self.sendTimeT.GetValue())
		ret=(label,data)
		return ret
	

	def setData(self,data):
		self.numProcT.SetValue(data[0])
		self.syncTimeT.SetValue(data[1])
		self.sendTimeT.SetValue(data[2])

class NOWSetPan(scrolled.ScrolledPanel):
	def __init__(self,parent):
		
		scrolled.ScrolledPanel.__init__(self,parent,-1)
		figbox_title=wx.StaticBox(self,-1,'NOW Machine Setup')
		figbox_title.SetFont(wx.Font(10,wx.FONTFAMILY_MODERN, wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD,False))
		figbox=wx.StaticBoxSizer(figbox_title, wx.VERTICAL)
		sizFig=wx.FlexGridSizer(cols=4,hgap=5,vgap=10)
		self.numProcL=wx.StaticText(self,-1, 'Number Of Processors:')
		self.numProcT=wx.TextCtrl(self,-1,"",size=(75, -1))
		
		sizFig.Add(self.numProcL)
		sizFig.Add(self.numProcT)
		
		self.fanInL=wx.StaticText(self,-1, 'Barrier Tree Fan In:',size=(115, 20),style=wx.RAISED_BORDER)
		self.fanInT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.fanInL)
		sizFig.Add(self.fanInT)
		
		self.fanOutL=wx.StaticText(self,-1, 'Barrier Tree Fan Out:',size=(115, 20),style=wx.SUNKEN_BORDER)
		self.fanOutT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.fanOutL)
		sizFig.Add(self.fanOutT)
		
		sizFig.Add((0,0))
		self.noiseCheck=wx.CheckBox(self,-1,'Activate Ethernet Noise')
		sizFig.Add((0,0))
		sizFig.Add(self.noiseCheck)
		sizFig.Add((0,0))
		sizFig.Add((0,0))
		sizFig.Add((0,0))
		
		self.noiseTimL=wx.StaticText(self,-1, 'Time Between Noise:',size=(115, 20),style=wx.RAISED_BORDER)
		self.noiseTimT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.noiseTimL)
		sizFig.Add(self.noiseTimT)
		
		self.pacOverHL=wx.StaticText(self,-1, 'Packet Overhead:',size=(115, 20),style=wx.SUNKEN_BORDER)
		self.pacOverHT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.pacOverHL)
		sizFig.Add(self.pacOverHT)
		
		self.minDataL=wx.StaticText(self,-1, 'Min Data Size:',size=(115, 20),style=wx.RAISED_BORDER)
		self.minDataT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.minDataL)
		sizFig.Add(self.minDataT)
		
		self.maxDataL=wx.StaticText(self,-1, 'Max Data Size:',size=(115, 20),style=wx.SUNKEN_BORDER)
		self.maxDataT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.maxDataL)
		sizFig.Add(self.maxDataT)
		
		self.maxRetL=wx.StaticText(self,-1, 'Max Retries:',size=(115, 20),style=wx.RAISED_BORDER)
		self.maxRetT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.maxRetL)
		sizFig.Add(self.maxRetT)
		
		self.maxBacL=wx.StaticText(self,-1, 'Max Backof:',size=(115, 20),style=wx.SUNKEN_BORDER)
		self.maxBacT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.maxBacL)
		sizFig.Add(self.maxBacT)
		
		
		self.bandL=wx.StaticText(self,-1, 'Bandwith:',size=(115, 20),style=wx.RAISED_BORDER)
		self.bandT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.bandL)
		sizFig.Add(self.bandT)
		
		
		self.intGapL=wx.StaticText(self,-1, 'Interframe Gap:',size=(115, 20),style=wx.SUNKEN_BORDER)
		self.intGapT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.intGapL)
		sizFig.Add(self.intGapT)
		
		self.proDelL=wx.StaticText(self,-1, 'Propagation Delay:',size=(115, 20),style=wx.RAISED_BORDER)
		self.proDelT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.proDelL)
		sizFig.Add(self.proDelT)
		
		self.sloTimeL=wx.StaticText(self,-1, 'Slot Time',size=(115, 20),style=wx.SUNKEN_BORDER)
		self.sloTimeT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.sloTimeL)
		sizFig.Add(self.sloTimeT)
		
		self.jamDelL=wx.StaticText(self,-1, 'Jam Delay:',size=(115, 20),style=wx.RAISED_BORDER)
		self.jamDelT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.jamDelL)
		sizFig.Add(self.jamDelT)
		
		
		figbox.Add(sizFig)
		self.SetSizer(figbox)
		self.SetAutoLayout(True)
		#parent.boxSiz.Layout()
		#parent.parent.figbox.Layout(True)
		parent.Refresh()
		#self.SetupScrolling()
		#self.getData()
	def getData(self):
		label=[]
		data=[]
		
		label.append("[NumberOfProcessors]")
		data.append(self.numProcT.GetValue())
		
		label.append("[Bus_BarrierTreeFanIn]")
		data.append(self.fanInT.GetValue())
		
		label.append("[Bus_BarrierTreeFanOut]")
		data.append(self.fanOutT.GetValue())
		
		#label.append("[Bus_BarrierTreeFanOut]")
		#data.append(self.fanOutT.GetValue())
		
		label.append("[NOW_NoiseActivated]")
		if self.noiseCheck.GetValue()==True:
			data.append("True")
		else:
			data.append("False")
		
		label.append("[NOW_TimeBetweenNoise]")
		data.append(self.noiseTimT.GetValue())
		
		
		label.append("[Ethernet_PacketOverhead]")
		data.append(self.pacOverHT.GetValue())
		
		label.append("[Ethernet_MinDataSize]")
		data.append(self.minDataT.GetValue())
		
		label.append("[Ethernet_MaxDataSize]")
		data.append(self.maxDataT.GetValue())
		
		label.append("[Ethernet_MaxRetries]")
		data.append(self.maxRetT.GetValue())
		
		label.append("[Ethernet_MaxBackoff]")
		data.append(self.maxBacT.GetValue())
		
		label.append("[Ethernet_BandWidth]")
		data.append(self.bandT.GetValue())
		
		label.append("[Ethernet_InterFrameGap]")
		data.append(self.intGapT.GetValue())
		
		label.append("[Ethernet_PropagationDelay]")
		data.append(self.proDelT.GetValue())
		
		label.append("[Ethernet_SlotTime]")
		data.append(self.sloTimeT.GetValue())
		
		label.append("[Ethernet_JamDelay]")
		data.append(self.jamDelT.GetValue())
		
		
		ret=(label,data)
		return ret
	def setData(self,data):
		self.numProcT.SetValue(data[0])
		self.fanInT.SetValue(data[1])
		self.fanOutT.SetValue(data[2])
		self.noiseCheck.SetValue(bool(data[3]))
		self.noiseTimT.SetValue(data[4])
		self.pacOverHT.SetValue(data[5])
		self.minDataT.SetValue(data[6])
		self.maxDataT.SetValue(data[7])
		self.maxRetT.SetValue(data[8])
		self.maxBacT.SetValue(data[9])
		self.bandT.SetValue(data[10])
		self.intGapT.SetValue(data[11])
		self.proDelT.SetValue(data[12])
		self.sloTimeT.SetValue(data[13])
		self.jamDelT.SetValue(data[14])
		

	
	
class BusSetPan(wx.Panel):
	def __init__(self,parent):
		
		wx.Panel.__init__(self,parent,-1)
		figbox_title=wx.StaticBox(self,-1,'Bus Machine Setup')
		figbox_title.SetFont(wx.Font(10,wx.FONTFAMILY_MODERN, wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD,False))
		figbox=wx.StaticBoxSizer(figbox_title, wx.VERTICAL)
		sizFig=wx.FlexGridSizer(cols=2,hgap=5,vgap=10)
		self.numProcL=wx.StaticText(self,-1, 'Number Of Processors')
		self.numProcT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add((15,15))
		sizFig.Add((15,15))
		sizFig.Add(self.numProcL)
		sizFig.Add(self.numProcT)
		self.fanInL=wx.StaticText(self,-1, 'Barrier Tree Fan In:',size=(115, 20),style=wx.RAISED_BORDER)
		self.fanInT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.fanInL)
		sizFig.Add(self.fanInT)
				
		self.fanOutL=wx.StaticText(self,-1, 'Barrier Tree Fan Out:',size=(115, 20),style=wx.SUNKEN_BORDER)
		self.fanOutT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.fanOutL)
		sizFig.Add(self.fanOutT)
		
		self.busWidL=wx.StaticText(self,-1, 'Processor Bus Width:',size=(115, 20),style=wx.SUNKEN_BORDER)
		self.busWidT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.busWidL)
		sizFig.Add(self.busWidT)
		
		self.busFrqL=wx.StaticText(self,-1, 'Processor Bus Frequency:',size=(115, 20),style=wx.SUNKEN_BORDER)
		self.busFrqT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.busFrqL)
		sizFig.Add(self.busFrqT)
		
		self.busArbGapL=wx.StaticText(self,-1, 'Processor Bus Arbitraton Gap:',size=(200, 20),style=wx.SUNKEN_BORDER)
		self.busArbGapT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.busArbGapL)
		sizFig.Add(self.busArbGapT)
		
		figbox.Add(sizFig)
		self.SetSizer(figbox)
		
		
		
	def getData(self):
		label=[]
		data=[]
			
		label.append("[NumberOfProcessors]")
		data.append(self.numProcT.GetValue())
			
		label.append("[Bus_BarrierTreeFanIn]")
		data.append(self.fanInT.GetValue())
			
		label.append("[Bus_BarrierTreeFanOut]")
		data.append(self.fanOutT.GetValue())
		
		label.append("[ProcessorBus_Width]")
		data.append(self.busWidT.GetValue())
		
		label.append("[ProcessorBus_Frequency]")
		data.append(self.busFrqT.GetValue())
		
		label.append("[ProcessorBus_ArbitrationGap]")
		data.append(self.busArbGapT.GetValue())
		
		return (label,data)
		
	def setData(self,data):
		self.numProcT.SetValue(data[0])
		self.fanInT.SetValue(data[1])
		self.fanOutT.SetValue(data[2])
		self.busWidT.SetValue(data[3])
		self.busFrqT.SetValue(data[4])
		self.busArbGapT.SetValue(data[5])
		
		
class NetworkSetPan(wx.Panel):
	def __init__(self,parent):
		
		wx.Panel.__init__(self,parent,-1)
		figbox_title=wx.StaticBox(self,-1,'Network Machine Setup')
		figbox_title.SetFont(wx.Font(10,wx.FONTFAMILY_MODERN, wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD,False))
		figbox=wx.StaticBoxSizer(figbox_title, wx.VERTICAL)
		sizFig=wx.FlexGridSizer(cols=2,hgap=5,vgap=10)
		sizFig.Add((15,15))
		sizFig.Add((15,15))
		
		
		topTSiz=wx.BoxSizer(wx.HORIZONTAL)
		self.topL=wx.StaticText(self,-1, 'Network Topology:')
		self.rNull=wx.RadioButton(self, -1, 'TwoDTorus',style = wx.RB_GROUP)
		self.rSimple=wx.RadioButton(self,-1,'TwoDMesh')
		self.rNow=wx.RadioButton(self,-1,'TwoDMeshHP')
		self.rBus=wx.RadioButton(self,-1,'ThreeDMesh')
		self.rNet=wx.RadioButton(self,-1,'HypeCube')
		self.rGroup=[]
		self.rGroup.append(self.rNull)
		self.rGroup.append(self.rSimple)
		self.rGroup.append(self.rNow)
		self.rGroup.append(self.rBus)
		self.rGroup.append(self.rNet)
		for radio in self.rGroup:
			self.Bind(wx.EVT_RADIOBUTTON, self.OnTopSelect, radio )
		
		topTSiz.Add(self.rNull)
		topTSiz.Add((3,3))
		topTSiz.Add(self.rSimple)
		topTSiz.Add((3,3))
		topTSiz.Add(self.rNow)
		topTSiz.Add((3,3))
		topTSiz.Add(self.rBus)
		topTSiz.Add((3,3))
		topTSiz.Add(self.rNet)
		sizFig.Add(self.topL)	
		sizFig.Add(topTSiz)

		
		
		self.xSizeL=wx.StaticText(self,-1, 'X-Size')
		self.xSizeT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.xSizeL)
		sizFig.Add(self.xSizeT)
		
		self.ySizeL=wx.StaticText(self,-1, 'Y-Size')
		self.ySizeT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.ySizeL)
		sizFig.Add(self.ySizeT)
		
		self.zSizeL=wx.StaticText(self,-1, 'Z-Size')
		self.zSizeT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.zSizeL)
		sizFig.Add(self.zSizeT)
		
		self.dimL=wx.StaticText(self,-1, 'Network Dimention')
		self.dimT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.dimL)
		sizFig.Add(self.dimT)
		
		portTSiz=wx.BoxSizer(wx.HORIZONTAL)
		self.portL=wx.StaticText(self,-1, 'Communication Architecure:')
		self.rOnePort=wx.RadioButton(self, -1, 'One Port',style = wx.RB_GROUP)
		self.rAllPort=wx.RadioButton(self,-1,'All Port')
		portTSiz.Add(self.rOnePort)
		portTSiz.Add((3,3))
		portTSiz.Add(self.rAllPort)
				
		sizFig.Add(self.portL)
		sizFig.Add(portTSiz)

		
		mesTSiz=wx.BoxSizer(wx.HORIZONTAL)
		self.mesL=wx.StaticText(self,-1, 'Message Passing:')
		self.rHazard=wx.RadioButton(self, -1, 'Hazard',style = wx.RB_GROUP)
		self.rSafe=wx.RadioButton(self,-1,'Safe')
		mesTSiz.Add(self.rHazard)
		mesTSiz.Add((3,3))
		mesTSiz.Add(self.rSafe)
		
		sizFig.Add(self.mesL)
		sizFig.Add(mesTSiz)

		
		
		
		
		self.tranTimL=wx.StaticText(self,-1, 'Transission Time')
		self.tranTimT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.tranTimL)
		sizFig.Add(self.tranTimT)
		
		self.startLatL=wx.StaticText(self,-1, 'Startup Latancy')
		self.startLatT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.startLatL)
		sizFig.Add(self.startLatT)
		
		prioTSiz=wx.BoxSizer(wx.HORIZONTAL)
		self.prioL=wx.StaticText(self,-1, 'Output Priority:')
		self.rFifo=wx.RadioButton(self, -1, 'FIFO',style = wx.RB_GROUP)
		self.rRandom=wx.RadioButton(self,-1,'Random')
		prioTSiz.Add(self.rFifo)
		prioTSiz.Add((3,3))
		prioTSiz.Add(self.rRandom)
				
		sizFig.Add(self.prioL)
		sizFig.Add(prioTSiz)

		
		routTSiz=wx.BoxSizer(wx.HORIZONTAL)
		self.routL=wx.StaticText(self,-1, 'Routing Method:')
		self.rTwoPWorm=wx.RadioButton(self, -1, 'TWOPhaseWorm',style = wx.RB_GROUP)
		self.rWorm=wx.RadioButton(self,-1,'Worm')
		self.rStoAndForw=wx.RadioButton(self,-1,'Store And Forward')
		routTSiz.Add(self.rTwoPWorm)
		routTSiz.Add((3,3))
		routTSiz.Add(self.rWorm)
		routTSiz.Add((3,3))
		routTSiz.Add(self.rStoAndForw)
						
		sizFig.Add(self.routL)
		sizFig.Add(routTSiz)
	
		
		delTSiz=wx.BoxSizer(wx.HORIZONTAL)
		self.delL=wx.StaticText(self,-1, 'Delayed Messages:')
		self.rDelOn=wx.RadioButton(self, -1, 'On',style = wx.RB_GROUP)
		self.rDelOff=wx.RadioButton(self,-1,'Off')
		delTSiz.Add(self.rDelOn)
		delTSiz.Add((3,3))
		delTSiz.Add(self.rDelOff)
						
		sizFig.Add(self.delL)
		sizFig.Add(delTSiz)
		
		
		squSiz=wx.BoxSizer(wx.HORIZONTAL)
		self.squL=wx.StaticText(self,-1, 'Node From Square:')
		self.rSquOn=wx.RadioButton(self, -1, 'True',style = wx.RB_GROUP)
		self.rSquOff=wx.RadioButton(self,-1,'False')
		squSiz.Add(self.rSquOn)
		squSiz.Add((3,3))
		squSiz.Add(self.rSquOff)
								
		sizFig.Add(self.squL)
		sizFig.Add(squSiz)
	
		
		self.maxPacL=wx.StaticText(self,-1, 'Max Packet Size:')
		self.maxPacT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.maxPacL)
		sizFig.Add(self.maxPacT)
		
		self.grainSizL=wx.StaticText(self,-1, 'Grain Size:')
		self.grainSizT=wx.TextCtrl(self,-1,"",size=(75, -1))
		sizFig.Add(self.grainSizL)
		sizFig.Add(self.grainSizT)
		
		
		
		
		
		
		
		figbox.Add(sizFig)
		self.SetSizer(figbox)
		
	def getData(self):
	        label=[]
	        data=[]
	        if self.rNull.GetValue():
	        	label.append("[Network_Topology]")
	        	data.append("TwoDTorus")
	        elif self.rSimple.GetValue():
	        	label.append("[Network_Topology]")
	        	data.append("TwoDMesh")
	        
	        elif self.rBus.GetValue():
	        	label.append("[Network_Topology]")
	        	data.append("TwoDMeshHP")
	        elif self.rNow.GetValue():
		        label.append("[Network_Topology]")
	        	data.append("ThreeDMesh")
	        else:	
	        	
			label.append("[Network_Topology]")
        		data.append("HyperCube")
        		
        	label.append("[Network_Xsize]")
		data.append(self.xSizeT.GetValue())
		
		label.append("[Network_Ysize]")
		data.append(self.ySizeT.GetValue())
		
		label.append("[Network_Zsize]")
		data.append(self.zSizeT.GetValue())
		
		label.append("[Network_Dim]")
		data.append(self.dimT.GetValue())
		
		if self.rOnePort.GetValue():
			label.append("[Network_PortModel]")
			data.append("OnePort")
		else:
			label.append("[Network_PortModel]")
	        	data.append("AllPort")
	        
	        if self.rSafe.GetValue():
			label.append("[Network_Stability]")
			data.append("Safe")
		else:
			label.append("[Network_Stability]")
	        	data.append("Hazard")
	        
	        label.append("[Network_TransTime]")
		data.append(self.tranTimT.GetValue())
		
		label.append("[Network_StartUpLat]")
		data.append(self.startLatT.GetValue())
		
		if self.rFifo.GetValue():
			label.append("[Network_OutPortPriority]")
			data.append("Fifo")
		else:
			label.append("[Network_OutPortPriority]")
	        	data.append("Random")
		
		if self.rTwoPWorm.GetValue():
			label.append("[Network_RoutingMethod]")
			data.append("TwoPhaseWorm")
		elif self.rWorm.GetValue():
			label.append("[Network_RoutingMethod]")
	        	data.append("Worm")
	        else:
	        	label.append("[Network_RoutingMethod]")
	        	data.append("StoreAndForward")
	        
	        label.append("[DelayedMessages]")
	        if self.rDelOn.GetValue():
			data.append("On")
		else:
			data.append("Off")
			
		label.append("[Intermediate_node_from_square]")
		if self.rSquOn.GetValue():
			data.append("True")
		else:
			data.append("False")
			
		label.append("[NetworkMaxPacketSize]")
		data.append(self.maxPacT.GetValue())
		
		label.append("[Network_VirtualChannel_Simulation_GrainSize]")
		data.append(self.grainSizT.GetValue())
		
		return (label,data)
	

	def setData(self,data):
		if data[0]=="TwoDTorus":
			self.rNull.SetValue(True)
		elif data[0]=="TwoDMesh":
			self.rSimple.SetValue(True)
		elif data[0]=="TwoDMeshHp":
			self.rBus.SetValue(True)
		elif data[0]=="ThreeDMesh":
			self.rNow.SetValue(True)
		else:
			self.rNet.SetValue(True)
		
		self.xSizeT.SetValue(data[1])
		self.ySizeT.SetValue(data[2])
		self.zSizeT.SetValue(data[3])
		self.dimT.SetValue(data[4])
		
		if data[5]=="OnePort":
			self.rOnePort.SetValue(True)
		else:
			self.rOAllPort.SetValue(True)
		
		
		if data[6]=="Safe":
			self.rSafe.SetValue(True)
		else:
			self.rHazard.SetValue(True)
		
		self.tranTimT.SetValue(data[7])
		self.startLatT.SetValue(data[8])
		
		if data[9]=="Fifo":
			self.rFifo.SetValue(True)
		else:
			self.rRandom.SetValue(True)
		
		if data[10]=="TwoPhaseWorm":
			self.rTwoPWorm.SetValue(True)
		elif data[10]=="Worm":
			self.rWorm.SetValue(True)
		else:
			self.rStoAndForw.SetValue(True)
		
		if data[11]=="On":
			self.rDelOn.SetValue(True)
		else:
			self.rDelOff.SetValue(True)
		if data[12]=="True":
			self.rSquOn.SetValue(True)
		else:
			self.rSquOff.SetValue(True)
		
		self.maxPacT.SetValue(data[13])
		self.grainSizT.SetValue(data[14])
		
		
		
		
	
	def OnTopSelect(self,event):
		None
