#Logsetup under setupdelen
import wx
class LogSetup(wx.Panel):
	def __init__(self,parent,data):
		wx.Panel.__init__(self,parent,-1)
		self.data=data
		figbox_title=wx.StaticBox(self,-1,'Log Values')
		figbox_title.SetFont(wx.Font(13,wx.FONTFAMILY_MODERN, wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD,False))
		figbox=wx.StaticBoxSizer(figbox_title, wx.VERTICAL)
		sizFig=wx.FlexGridSizer(cols=2,hgap=5,vgap=10)
		
		
		self.ssSentData=wx.CheckBox(self,-1,'SuperStep Sent Data')
		self.ssRecData=wx.CheckBox(self,-1,'SuperStep Received Data')
		self.ssTimeSpent=wx.CheckBox(self,-1,'SuperStep Time Spent')
		self.ssSyncTimeSpent=wx.CheckBox(self,-1,'SuperStep Sycr Time Spent')
		self.ssDrmaSent=wx.CheckBox(self,-1,'SuperStep DRMA Sent')
		self.ssDrmaRec=wx.CheckBox(self,-1,'SuperStep DRMA Received')
		self.ssBSMPSent=wx.CheckBox(self,-1,'SuperStep BSMP Sent')
		self.ssBSMPRec=wx.CheckBox(self,-1,'SuperStep BSMP Received')
		
		sizFig.Add((15,15))
		sizFig.Add((15,15))
		
		
		sizFig.Add(self.ssSentData)
		sizFig.Add(self.ssRecData)
		sizFig.Add(self.ssTimeSpent)
		sizFig.Add(self.ssSyncTimeSpent)
		sizFig.Add(self.ssDrmaSent)
		sizFig.Add(self.ssDrmaRec)
		sizFig.Add(self.ssBSMPSent)
		sizFig.Add(self.ssBSMPRec)
		
		self.ssTotSentData=wx.CheckBox(self,-1,'Total SuperStep Sent Data')
		self.ssTotRecData=wx.CheckBox(self,-1,'Total SuperStep Received Data')
		self.ssTotTimeSpent=wx.CheckBox(self,-1,'Average SuperStep Time Spent')
		self.ssTotSyncTimeSpent=wx.CheckBox(self,-1,'Average SuperStep Sycr Time Spent')
		self.ssTotDrmaSent=wx.CheckBox(self,-1,'Total SuperStep DRMA Sent')
		self.ssTotBSMPSent=wx.CheckBox(self,-1,'Total SuperStep BSMP Sent')
		self.ssTotBSMPRec=wx.CheckBox(self,-1,'Total SuperStep BSMP Received')
		
		sizFig.Add(self.ssTotSentData)
		sizFig.Add(self.ssTotRecData)
		sizFig.Add(self.ssTotTimeSpent)
		sizFig.Add(self.ssTotSyncTimeSpent)
		sizFig.Add(self.ssTotDrmaSent)
		sizFig.Add(self.ssTotBSMPSent)
		sizFig.Add(self.ssTotBSMPRec)
		
		
		self.totSentData=wx.CheckBox(self,-1,'Total Sent Data')
		self.totRecData=wx.CheckBox(self,-1,'Total Received Data')
		self.totTimeSpent=wx.CheckBox(self,-1,'Total Time Spent')
		self.totSyncTimeSpent=wx.CheckBox(self,-1,'Total Sycr Time Spent')
		self.totDrmaSent=wx.CheckBox(self,-1,'Total DRMA Sent')
		self.totBSMPSent=wx.CheckBox(self,-1,'Total BSMP Sent')
		self.totBSMPRec=wx.CheckBox(self,-1,'Total BSMP Received')
		
		sizFig.Add(self.totSentData)
		sizFig.Add(self.totRecData)
		sizFig.Add(self.totTimeSpent)
		sizFig.Add(self.totSyncTimeSpent)
		sizFig.Add(self.totDrmaSent)
		sizFig.Add(self.totBSMPSent)	 
		sizFig.Add(self.totBSMPRec)
		figbox.Add(sizFig)
		self.saveBtn=wx.Button(self,-1,'Save Changes')
		self.Bind(wx.EVT_BUTTON,self.OnSavePress,self.saveBtn)
	        figbox.Add((15,15))
	        figbox.Add(self.saveBtn)
		self.SetSizer(figbox)
		if len(self.data[7]) >0:
			self.setData()
		
	def getData(self):
		data=[]
		label=[]
		data.append((self.ssSentData.GetValue()))
		data.append((self.ssRecData.GetValue()))
		data.append((self.ssTimeSpent.GetValue())) 
		data.append((self.ssSyncTimeSpent.GetValue()))
		data.append((self.ssDrmaSent.GetValue()))
		data.append((self.ssDrmaRec.GetValue()))
		data.append((self.ssBSMPSent.GetValue()))
		data.append((self.ssBSMPRec.GetValue()))
		
		data.append((self.ssTotSentData.GetValue()))
		data.append((self.ssTotRecData.GetValue()))
		data.append((self.ssTotTimeSpent.GetValue()))
		data.append((self.ssTotSyncTimeSpent.GetValue()))
		data.append((self.ssTotDrmaSent.GetValue()))
		data.append((self.ssTotBSMPSent.GetValue()))
		data.append((self.ssTotBSMPRec.GetValue()))

		data.append((self.totSentData.GetValue()))
		data.append((self.totRecData.GetValue()))
		data.append((self.totTimeSpent.GetValue()))
		data.append((self.totSyncTimeSpent.GetValue()))
		data.append((self.totDrmaSent.GetValue()))
		data.append((self.totBSMPSent.GetValue()))
		data.append((self.totBSMPRec.GetValue()))

		
		label.append("[LogSuperstepSentData]")
		label.append("[LogSuperstepReceivedData]")
		label.append("[LogSuperstepTimeSpent]")
		label.append("[LogBarrierSyncTimeSpent]")
		label.append("[LogSuperstepDRMASent]") 
		label.append("[LogSuperstepDRMAReceived]")
		label.append("[LogSuperstepBSMPSent]") 
		label.append("[LogSuperstepBSMPReceived]") 

		label.append("[LogTotalSuperstepSentData]") 
		label.append("[LogTotalSuperstepReceivedData]")
		label.append("[LogAvgSuperstepTimeSpent]") 
		label.append("[LogAvgBarrierSyncTimeSpent]")
		label.append("[LogTotalSuperstepDRMASent]") 
		label.append("[LogTotalSuperstepBSMPSent]") 
		label.append("[LogTotalSuperstepBSMPReceived]")

		label.append("[LogTotalSentData]")
		label.append("[LogTotalReceivedData]") 
		label.append("[LogTotalTimeSpent]") 
		label.append("[LogTotalBarrierSyncTimeSpent]")
		label.append("[LogTotalDRMASent]")
		label.append("[LogTotalBSMPSent]")
		label.append("[LogTotalBSMPReceived]")
		
		self.data[7]=(label,data)
		
			
		
	def setData(self):
		data=self.data[7]
		self.ssSentData.SetValue(bool(data[1][0]))
		self.ssRecData.SetValue(bool(data[1][1]))
		self.ssTimeSpent.SetValue(bool(data[1][2]))
		self.ssSyncTimeSpent.SetValue(bool(data[1][3]))
		self.ssDrmaSent.SetValue(bool(data[1][4]))
		self.ssDrmaRec.SetValue(bool(data[1][5]))
		self.ssBSMPSent.SetValue(bool(data[1][6]))
		self.ssBSMPRec.SetValue(bool(data[1][7]))
		
		self.ssTotSentData.SetValue(bool(data[1][8]))
		self.ssTotRecData.SetValue(bool(data[1][9]))
		self.ssTotTimeSpent.SetValue(bool(data[1][10]))
		self.ssTotSyncTimeSpent.SetValue(bool(data[1][11]))
		self.ssTotDrmaSent.SetValue(bool(data[1][12]))
		self.ssTotBSMPSent.SetValue(bool(data[1][13]))
		self.ssTotBSMPRec.SetValue(bool(data[1][14]))
		
		self.totSentData.SetValue(bool(data[1][15]))
		self.totRecData.SetValue(bool(data[1][16]))
		self.totTimeSpent.SetValue(bool(data[1][17]))
		self.totSyncTimeSpent.SetValue(bool(data[1][18]))
		self.totDrmaSent.SetValue(bool(data[1][19]))
		self.totBSMPSent.SetValue(bool(data[1][20]))
		self.totBSMPRec.SetValue(bool(data[1][21]))
		
	def OnSavePress(self,event):
		self.getData()