#Matplotlib og selve figurplottinga
import matplotlib as mpl
mpl.use('WX')
import pylab as pl
import matplotlib.backends.backend_wx as mwx
import sys, cPickle
import wx
import matplotlib.backends.backend_wx as bk
import matplotlib.figure as Fig
import math
import os
class PlotFig(wx.Panel):
    def __init__(self,parent):
        wx.Panel.__init__(self,parent, -1)
        self.parent=parent
       
        self.plotData=[]
        self.fig=pl.Figure((9,8),75)
        self.canvas = mwx.FigureCanvasWx(self, -1, self.fig)
        self.toolbar = mwx.Toolbar(self.canvas)
        self.toolbar.Realize()
        self.figData=['',None,'',0,'','Linear',0,None,0,0,'Linear',0]
        
        tw, th = self.toolbar.GetSizeTuple()
        fw, fh = self.canvas.GetSizeTuple()
        self.toolbar.SetSize(wx.Size(fw, th))
        self.toolbar.Bind(wx.EVT_TOOL, self.Test)
        
                
        self.figmgr = mwx.FigureManager(self.canvas, 1, self)
        self.sizer = wx.BoxSizer(wx.VERTICAL)
        self.sizer.Add(self.canvas, 1, wx.LEFT|wx.TOP|wx.GROW)
        self.sizer.Add(self.toolbar, 0, wx.GROW)
        self.SetSizer(self.sizer)
        self.Fit()
        
        self.t=self.fig.add_subplot(111)
        self.color=['b','g','r','c','m','y','k']
        self.marker=['o-','x-','|-','D-','+-','<-','>-']
        self.m=0
        self.c=0

    def OnSize(self, evt):
        self.Refresh()
        
        
    #Metoden der dataene blir plottet i figuren
    
    def plotdata(self, plotpar, data,u):
        if data[0]==1:
            if data[1][0]!=3:
                t=data[1][1].keys()
                t.sort()    
                i=0

                for item in t:
                    print item
                    plotpar.t.plot(data[1][1][item][2],plotpar.color[self.c]+plotpar.marker[self.m],label='P:'+str(item))
                    i=i+1
                    if self.c !=6:
                        self.c=self.c+1
                    else:
                        self.c=0
                        self.m=self.m+1
                            
            else:
                plotpar.t.plot(data[1][1][2])
                
        else:
            plotpar.t.plot(data[1][2])
        if u==0:
            self.plotData.append(data)
            
        
        i=self.parent
        i.setupPan.addData(data)
        self.canvas.draw()
        plotpar.getFigVal()
        
        
        
     
    def clearFig(self):
        
        self.t.clear()
        self.plotData=[]
        self.t.set_xscale('linear')
        self.t.set_yscale('linear')
        self.t.set_title('')
        self.t.set_xlim((0,1))
        self.t.set_xlabel('')
        self.t.set_ylim((0,1))
        self.t.set_ylabel('')
        self.getFigVal()
        self.m=0
        self.c=0
        
        self.parent.Refresh()
    def getFigVal(self):
        data=[]
        xlim=self.t.get_xlim()
        ylim=self.t.get_ylim()
        xscale=self.t.get_xscale()
        yscale=self.t.get_yscale()
        data.append(xlim)
        data.append(ylim)
        data.append(xscale)
        data.append(yscale)
        data.append(self.figData[0])
        data.append(self.figData[2])
        data.append(self.figData[4])
        self.figData[1]=xlim
        self.figData[5]=xscale
        self.figData[3]=ylim
        self.figData[7]=yscale
        #print self.figData
        
        y=self.parent
        y.plotSetupPan.setVal(data)
        return data
    def setFigVal(self,data):
    	self.t.set_xscale(data[5],basex=float(data[6]))
        self.t.set_yscale(data[7],basey=float(data[8]))
        self.t.set_title(data[0])
        self.t.set_xlim([(data[1][0]),(data[1][1])])
        self.t.set_xlabel(data[2])
        self.t.set_ylim([(data[3][0]),(data[3][1])])
        self.t.set_ylabel(data[4])
        self.t.set_xscale(data[5],basex=float(data[6]))
        self.t.set_yscale(data[7],basey=float(data[8]))

        r=self.t.get_legend()
        if r!=None:
            if data[9]=='on':
                r.set_visible(b=True)
            else:
                r.set_visible(b=False)
        else:
            if data[9]=='on':
                self.t.legend(loc=2,isaxes=True,labelsep = 0,pad = 0.01  )
        if data[10]=='on':
            self.t.grid(b=True)
        else:
            self.t.grid(b=False)
        self.figData[0]=data[0]#figtitle
        self.figData[1]=data[1]#xlim
        self.figData[2]=data[2]#xlabel
        self.figData[3]=data[3]#ylim
        self.figData[4]=data[4]#ylabel
        self.figData[5]=data[5]#xscale
        self.figData[6]=data[6]#xbase
        self.figData[7]=data[7]#yscale
        self.figData[8]=data[8]#ybase
        self.figData[9]=data[9]#showlegend
        self.figData[10]=data[10]#showgrid
        
        
        self.canvas.draw()
        
                        
                        
    def xStep(self):
        xl=self.t.get_xlim()
        x1 =((xl[1]-xl[0])/2)
        if (xl[1]-xl[0])>=1:
            x2=x1*0.05
            x2=math.ceil(x2)
        else:
            x2=x1*0.1

        return x2

    def yStep(self):
        yl=self.t.get_ylim()
        y1 =((yl[1]-yl[0])/2)
        if (yl[1]-yl[0])>=1:
            y2=y1*0.05
            y2=math.ceil(y2)
        else:
            y2=y1*0.05

        return y2
    
        
    

    def GetToolBar(self):
        return self.toolbar
    def Test(self,event):
        try:
            id=event.GetId()
            print id
            xlim=self.t.get_xlim()
            ylim=self.t.get_ylim()
            if id==104:
                self.t.set_xlim((xlim[0]-(self.xStep())),(xlim[1]-(self.xStep())))
                self.canvas.draw()
                
            elif id==105:
                self.t.set_xlim((xlim[0]+(self.xStep())),(xlim[1]+(self.xStep())))
                self.canvas.draw()
            elif id==106:
                self.t.zoomx(1)
                self.canvas.draw()#self.t.draw()#Refresh()
            elif id==107:
                self.t.zoomx(-1)
                self.canvas.draw()
            elif id==109:
                self.t.set_ylim((ylim[0]-(self.yStep())),(ylim[1]-(self.yStep())))
                self.canvas.draw()
            elif id ==108:
                self.t.set_ylim((ylim[0]+(self.yStep())),(ylim[1]+(self.yStep())))
                self.canvas.draw()
            elif id==110:
                self.t.zoomy(1)
                self.canvas.draw()
            elif id ==111:
                self.t.zoomy(-1)
                self.canvas.draw()
            
            elif id==112:
                dlg = wx.FileDialog(
                self, message="Save Figure",  
                defaultFile="", wildcard="jpg(*.jpg)|*.jpg", style=wx.SAVE
                )
                if dlg.ShowModal() == wx.ID_OK:
                    path = dlg.GetPath()
                    self.fig.savefig(path,dpi=250)
                    self.saveFig(path)
            self.getFigVal()
        except ValueError,e:
            msg=wx.MessageDialog(self, str(e),
                                   'Warning',
                                   wx.OK | wx.ICON_ERROR
                                   )
            msg.ShowModal()
            msg.Destroy()
    def removeFromFig(self,data):
        print 'remove'
        for element in self.plotData:
            if element[2]==data[0]:
                if data[1]==0:
                    self.plotData.remove(element)
                else:
                    print element[1][1].keys()
                    del element[1][1]['11']
                 
        self.t.clear()
        for elements in self.plotData:
            print 'e'
            self.plotdata(self,elements,1)
    def saveFig(self,path):
        newpath=''
        for char in path:
            if char=='.':
                break
            else:
                newpath=newpath+char
        newpath=newpath+'.fig'
        
        file=open(newpath,'w')
        cPickle.dump([self.figData,self.plotData], file)
        
    def openFig(self):
        openWin = wx.FileDialog(
            self, message="Choose a figure file", defaultDir=os.getcwd(), 
            defaultFile="", wildcard="figure file(*.fig)|*.fig", style=wx.OPEN | wx.CHANGE_DIR
            )
        if openWin.ShowModal()==wx.ID_OK:
            file=open(openWin.GetPath())
            figDat=[]
            all=[]
            first=True
            test=cPickle.load(file)
            for item in test[1]:
                self.plotdata(self,item,0)
            self.setFigVal(test[0])
            self.getFigVal()
                                
                            
                    
                        

            
    

            

            
                
    


