#Klasse for setup av setup av figurer i plottevrktoyet
import wx
class PlotSetup(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent,-1)
        space = 2
        setupval=[]
        self.parent=parent
        
        
        topBox_title=wx.StaticBox(self,-1,'Figure Setup')
        topBox=wx.StaticBoxSizer(topBox_title,wx.VERTICAL)
        
        #controls for general figure values
        figbox_title=wx.StaticBox(self,-1,'Figure Values')
        figbox=wx.StaticBoxSizer(figbox_title, wx.VERTICAL)
        sizFig=wx.FlexGridSizer(cols=2)
        self.figTitleL=wx.StaticText(self,-1, 'Figure Title')
        self.figTitleT=wx.TextCtrl(self,-1,"")#,size=(115, -1))
        self.legendCheck=wx.CheckBox(self,-1,'Show Legends')
        #self.legendPosBoxTitle=wx.StaticBox(self,-1,'Legend Position')
        #self.legendPosBox=wx.StaticBoxSizer(legendPosBoxTitle,wx.VERTICAL)
        #self.lPosBest=wx.RadioButton(self,-1,'Best',style=wx.RB_GROUP)
        self.gridCheck=wx.CheckBox(self,-1,'Show Grid')

        #Controls for X values 
        boxX_title = wx.StaticBox( self, -1, "X-values" )
        boxX=wx.StaticBoxSizer(boxX_title,wx.VERTICAL)
        self.xTitleL=wx.StaticText(self,-1, 'X-Title')
        self.xTitleT=wx.TextCtrl(self,-1,"")#,size=(125, -1))
        self.xTitleT.SetToolTip(wx.ToolTip("Title for the X-axis"))
        self.xminL=wx.StaticText(self,-1, 'X-min')
        self.xminT=wx.TextCtrl(self,-1,"")#,size=(100, -1))
        self.xminT.SetToolTip(wx.ToolTip("Minimum value for the X-axis"))
        self.xmaxL=wx.StaticText(self,-1, 'X-max')
        self.xmaxT=wx.TextCtrl(self,-1,"")#,size=(100, -1))
        self.r1X=wx.RadioButton(self, -1, 'Linear',style = wx.RB_GROUP)
        self.r2X=wx.RadioButton(self,-1,'Log')
        self.xBaseL=wx.StaticText(self,-1, 'X-Base')
        self.xBaseT=wx.TextCtrl(self,-1,"10")#,size=(50, -1))
        self.xBaseT.Enable(False)
        self.rGroupX=[]
        self.rGroupX.append(self.r1X)
        self.rGroupX.append(self.r2X)

        #Controls for Y values
        boxY_title = wx.StaticBox(self, -1, "Y-values" )
        boxY=wx.StaticBoxSizer(boxY_title, wx.VERTICAL)                           
        self.yTitleL=wx.StaticText(self,-1, 'Y-Title')
        self.yTitleT=wx.TextCtrl(self,-1,"",size=(125, -1))
        self.yTitleT.SetToolTip(wx.ToolTip("Title for the y-axis"))
        self.yminL=wx.StaticText(self,-1, 'Y-min')
        self.yminT=wx.TextCtrl(self,-1,"",size=(100, -1))
        self.ymaxL=wx.StaticText(self,-1, 'Y-max')
        self.ymaxT=wx.TextCtrl(self,-1,"",size=(100, -1))
        self.r1Y=wx.RadioButton(self, -1, 'Linear',style = wx.RB_GROUP)
        self.r2Y=wx.RadioButton(self,-1,'Log')
        self.yBaseL=wx.StaticText(self,-1, 'Y-Base')
        self.yBaseT=wx.TextCtrl(self,-1,"10",size=(50, -1))
        self.yBaseT.Enable(False)
        self.rGroupY=[]
        self.rGroupY.append(self.r1Y)
        self.rGroupY.append(self.r2Y)
        sizY = wx.FlexGridSizer(cols=2, hgap=space, vgap=space)
        sizX = wx.FlexGridSizer(cols=2, hgap=space, vgap=space)
        
       
        sizFig.Add(self.figTitleL,1,wx.GROW)
        sizFig.Add(self.figTitleT,1,wx.GROW)
        sizFig.Add((0,0),1,wx.GROW)
        sizFig.Add(self.legendCheck,1,wx.GROW)
        sizFig.Add((0,0),1,wx.GROW)
        sizFig.Add(self.gridCheck,1,wx.GROW)
        sizX.AddMany([self.xTitleL, self.xTitleT,
                     self.xminL,self.xminT,
                     self.xmaxL, self.xmaxT,
                     self.r1X,(0,0),
                     self.r2X,(0,0),
                     self.xBaseL, self.xBaseT,])
                     #wx.StaticText(self,-1,'Y-Values'),(0,0),(0,0),
                     #(0,0),yminL, yminT,
                     #(0,0),ymaxL, ymaxT])
    
        sizY.AddMany([self.yTitleL, self.yTitleT,
                     self.yminL,self.yminT,
                     self.ymaxL, self.ymaxT,
                     self.r1Y,(0,0),
                     self.r2Y,(0,0),
                     self.yBaseL, self.yBaseT])
        figbox.Add(sizFig,1,wx.GROW)
        boxX.Add(sizX,1,wx.GROW)
        boxY.Add(sizY,11,wx.GROW)
        self.updateButton=wx.Button(self,-1,'Add changes')
        self.updateButton.Bind(wx.EVT_BUTTON, self.OnUpdatePress)
        self.clearButton=wx.Button(self,-1,'Clear')
        self.clearButton.Bind(wx.EVT_BUTTON,self.onClearPress)
        topBox.Add(figbox,0,wx.GROW)
        topBox.Add(boxX,0,wx.GROW)
        topBox.Add(boxY,0,wx.GROW)
        topBox.Add(self.updateButton,0,wx.GROW)
        topBox.Add(self.clearButton,0,wx.GROW)
        self.SetSizer(topBox)
        self.SetAutoLayout(True)                
        for radio in self.rGroupX:
            self.Bind(wx.EVT_RADIOBUTTON, self.OnGroupXSelect, radio )
        for radio in self.rGroupY:
            self.Bind(wx.EVT_RADIOBUTTON, self.OnGroupYSelect, radio )

    def OnGroupXSelect(self,event):
        radio=event.GetEventObject()
        print radio.GetLabel()
        if radio.GetLabel()=="Linear":
            self.xBaseT.Enable(False)
        else:
            self.xBaseT.Enable(True)

    def OnGroupYSelect(self,event):
        radio=event.GetEventObject()
        print radio.GetLabel()
        if radio.GetLabel()=="Linear":
            self.yBaseT.Enable(False)
        else:
            self.yBaseT.Enable(True)
            
    def OnUpdatePress(self,event):
        try:
            setupval=[]
            setupval.append(self.figTitleT.GetValue())
            setupval.append([self.xminT.GetValue(),self.xmaxT.GetValue()])
            setupval.append(self.xTitleT.GetValue())
            setupval.append([self.yminT.GetValue(),self.ymaxT.GetValue()])
            setupval.append(self.yTitleT.GetValue())
            
           
            if self.r1X.GetValue()==True:
                setupval.append('linear')
            else:
                setupval.append('log')
            setupval.append(self.xBaseT.GetValue())
            if self.r1Y.GetValue()==True:
                setupval.append('linear')
            else:
                setupval.append('log')

        
            if float(self.yBaseT.GetValue())>float(1) or self.r1Y.GetValue()==True:
                 if float(self.xBaseT.GetValue())>float(1) or self.r1X.GetValue()==True:
                    setupval.append(self.yBaseT.GetValue())
                    
                 else:
                    msg=wx.MessageDialog(self, 'The logarimtic X-base has to be larger than 1',
                                   'Warning',
                                   wx.OK | wx.ICON_ERROR
                                   #wx.YES_NO | wx.NO_DEFAULT | wx.CANCEL | wx.ICON_INFORMATION
                                   )
                    msg.ShowModal()
                    msg.Destroy()
            else:
                msg=wx.MessageDialog(self, 'The logarimtic Y-base has to be larger than 1',
                                   'Warning',
                                   wx.OK | wx.ICON_ERROR
                              
                                   )
                msg.ShowModal()
                msg.Destroy()
            if self.legendCheck.GetValue():
                setupval.append('on')
            else:
                setupval.append('off')
            if self.gridCheck.GetValue():
                setupval.append('on')
            else:
                setupval.append('off')
            self.parent.plotPan.setFigVal(setupval)
            #print self.yBaseT.GetValue()
        except ValueError,e:
            msgr=wx.MessageDialog(self, str(e),
                                   'Warning',
                                   wx.OK | wx.ICON_ERROR
                
                                   )
            msgr.ShowModal()
            msgr.Destroy()
    def onClearPress(self,event):
        self.parent.plotPan.clearFig()
        self.parent.setupPan.deleteAll()
	self.figTitleT.SetValue('')

	self.xTitleT.SetValue('')
	self.yTitleT.SetValue('')
            
        
        
    def setVal(self,data):
        print data
        self.xminT.SetValue(str(data[0][0]))
        self.xmaxT.SetValue(str(data[0][1]))
        self.yminT.SetValue(str(data[1][0]))
        self.ymaxT.SetValue(str(data[1][1]))
        if data[2]=='linear':
            self.r1X.SetValue(True)
        else:
            self.r2X.SetValue(True)
        if data[3]=='linear':
            self.r1Y.SetValue(True)
        else:
            self.r2Y.SetValue(True)
        self.figTitleT.SetValue(data[4])
	self.xTitleT.SetValue(data[5])
	self.yTitleT.SetValue(data[6])
        
    
        
        
