#Hovedvidue for plotteverktoyet
import wx
import PlotFig

import logDataPane
import SetupPane
import PlotLeftPane
import PlotSetupPane
import TimeBars
class PlotPanel(wx.Panel):
    def __init__(self,parent,files):
        wx.Panel.__init__(self,parent,style=wx.DOUBLE_BORDER)
	
        self.SetAutoLayout(True)
        self.logData=self.parseData(files)
        self.dataPan=logDataPane.LogDataPane(self, self.logData,files)
        layout=wx.LayoutConstraints()
        layout.top.SameAs(self, wx.Top, 3)
        layout.left.SameAs(self, wx.Left, 3)
        layout.bottom.SameAs(self,wx.Bottom,3)
        layout.right.PercentOf(self,wx.Right, 20)
        self.dataPan.SetConstraints(layout)

        self.plotSetupPan=PlotSetupPane.PlotSetup(self)
        layout=wx.LayoutConstraints()
        layout.top.SameAs(self,wx.Top,3)
        layout.left.RightOf(self.dataPan, 0)
        layout.bottom.PercentOf(self,wx.Bottom,70)
        layout.right.PercentOf(self,wx.Right,35)
        self.plotSetupPan.SetConstraints(layout)

        self.plotPan=PlotFig.PlotFig(self)
        layout=wx.LayoutConstraints()
        layout.top.SameAs(self, wx.Top, 3)
        layout.left.RightOf(self.plotSetupPan, 0)
        layout.bottom.PercentOf(self,wx.Bottom,70)
        layout.right.SameAs(self,wx.Right,3)
        self.plotPan.SetConstraints(layout)


        
        self.setupPan=SetupPane.SetupPane(self)
        layout=wx.LayoutConstraints()
        layout.top.Below(self.plotSetupPan,0)
        layout.left.RightOf(self.dataPan, 0)
        layout.bottom.SameAs(self,wx.Bottom,3)
        layout.right.SameAs(self,wx.Right,3)
        self.setupPan.SetConstraints(layout)
        

        
       
    #Parser for alle resultatdata fra proberesults filer
    def parseData(self,files):
        alldata=[]
        for file in files:

            parsfile=open(file[0])
            line=parsfile.readline()
            start=0
            title=''
            pid=''
            logdata={}
            while (line!=''):
                parNr=0
                title=''
                ss=''
                pid=''
                val2=''
                val3=''
                val4=''
                val5=''
                val6=''
                val7=''
                i=0
                t=0
                type=0
                
                #print line
                line=parsfile.readline()
                for char in line:
                    
                    if start ==0:
                        if char=='*':
                            start=1
                            break
                    
                    else:
                        #tittel
                        if parNr==0:
                            if char!=';':
                                title=title+char
                            else: parNr=1
                        #SuperStep    
                        elif parNr==1:
                            if char!=';':
                                ss=ss+char
                            else:
                                parNr=2
                        #PID 
                        elif parNr==2:
                            if char!=';':
                                if char.isdigit():
                                    pid=pid+char
                                else:
                                    parNr=3
                        #Starttid/val
                        elif parNr==3:
                            if char!=';'and char!=':':
                                if char.isdigit()or t==1:
                                    t=1
                                    val2=val2+char
                                else:
                                    if char=='u':
                                        type=1
                            else:
                                if i==0 or i==1:
                                    i=i+1
                                else:
                                     parNr=4
                                     i=0
                                     t=0
                        #Stop/Count
                        elif parNr==4:
                            if char!=';'and char!=':':
                                if char.isdigit()or t==1:
                                    t=1
                                    val3=val3+char
                            else:
                                if i==0 or i==1:
                                    i=i+1
                                else:
                                     parNr=5
                                     i=0
                                     t=0
                        #Used/Min
                        elif parNr==5:
                            if char!=';'and char!=':':
                                if char.isdigit()or t==1:
                                    t=1
                                    val4=val4+char
                            else:
                                if i==0 or i==1:
                                    i=i+1
                                else:
                                     parNr=6
                                     i=0
                                     t=0
                        #Max
                        elif parNr==6 and type==1:
                            if char!=';'and char!=':':
                                if char.isdigit()or t==1:
                                    t=1
                                    val5=val5+char
                            else:
                                if i==0 or i==1:
                                    i=i+1
                                else:
                                     parNr=7
                                     i=0
                                     t=0
                        #Avg
                        elif parNr==7:
                            if char!=';'and char!=':':
                                if char.isdigit()or t==1:
                                    t=1
                                    val7=val7+char
                            else:
                                if i==0 or i==1:
                                    i=i+1
                                else:
                                     break;

                #Legger parameterverdiene i logdatastrukturen            
                if type==0 and title!='':
                 
                    
                    if logdata.has_key(title):
                        t=logdata[title][1]
                        if t.has_key(pid):
                            r=t[pid]
                            
                            r[0].append(float(val2))
                            r[1].append(float(val3))
                            r[2].append(float(val4))
                            
                        else:
                            y=[]

                            
                            y.append([float(val2)])
                            y.append([float(val3)])
                            y.append([float(val4)])
                            
                            )
                            t[pid]=y
                            
                    else:
                        y=[]

                        y.append([float(val2)])
                        y.append([float(val3)])
                        y.append([float(val4)])
                        #print y
                        #y.append(r)
                        logdata[title]=[1,{pid:y}]
                        #print logdata[title] 
                        
                    
                    
                elif title!='' and type==1:
                    if logdata.has_key(title):
                        t=logdata[title][1]
                        if pid!='':
                            
                            if t.has_key(pid):
                                r=t[pid]
                                r[0].append(float(val2))
                                r[1].append(float(val3))
                                r[2].append(float(val4))
                                
                            else:
                                y=[]

                                
                                y.append([float(val2)])
                                y.append([float(val3)])
                                y.append([float(val4)])
                                
                                
                                t[pid]=y
                                
                        else:
                            t[0].append(float(val2))
                            t[1].append(float(val3))
                            t[2].append(float(val4))
                            
                            
                    else:
                        y=[]

                        y.append([float(val2)])
                        y.append([float(val3)])
                        y.append([float(val4)])
 
                        if pid!='':
                            logdata[title]=[2,{pid:y}]
                                                   
                        else:
                            logdata[title]=[3,y]
                 
                    
                    None
            alldata.append(logdata)
        print 'parse'
        return alldata
    

